{% extends 'base.html' %}
{% load static %}
{% load custom_tags %}

{% block content %}
    <section id="forum-home" class="container">
        <div class="row">
            <div class="col-12">
                {% for message in messages %}
                    <div {% if message.tags %} class="alert {{ message.tags }} alert-dismissible shadow" {% endif %}>
                        <h5 class="text-center m-0">{{ message | safe }}</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                {% endfor %}
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <div class="card-body rounded p-5">
                    <div class="d-flex justify-content-between">
                        {% if not search_title and not search_category %}
                            <a href="{% url 'new_thread' %}" class="btn btn-primary">
                                <img class="white-img-filter align-text-bottom" src="{% static 'icons/add-black.svg' %}" width="20" alt="add-icon">
                                New discussion
                            </a>
                        {% else %}
                            <a class="btn btn-primary" href="{% url 'forum' %}">
                                <img class="white-img-filter align-text-bottom" src="{% static 'icons/undo.svg' %}" width="20" alt="undo-icon">
                                All discussions
                            </a>
                        {% endif %}

                        <form class="searchbar ui-widget" method="get">
                            <div class="d-flex">
                                <input id="search-thread" class="form-control border-0 ui-autocomplete-input" type="search"
                                       name="th-title" placeholder="Search discussion" aria-label="Search">
                                <input id="search-thread-id" type="hidden" name="th-id">
                                <button class="btn" type="submit">
                                    <img class="img-fluid" src="{% static 'icons/search.svg' %}" alt="search-icon">
                                </button>
                                <div id="menu-th-titles"></div>
                            </div>
                        </form>
                    </div>

                    <form class="categories mt-4" method="get">
                        <div class="row">
                            {% for category in categories %}
                                <div class="col">
                                    <button type="submit" name="th-category" value="{{ category }}" class="btn primary-text-color">{{ category }}</button>
                                </div>
                            {% endfor %}
                        </div>
                    </form>

                    {% if not page_obj %}
                        <h3 class="my-5 text-center dark-blue-text-color">Sorry, there were no results</h3>
                    {% else %}
                        <div class="table-responsive my-5">
                            <table class="table table-hover">
                                <thead class="align-middle text-center">
                                    <tr>
                                        <th scope="col">Title</th>
                                        <th scope="col">Category</th>
                                        <th scope="col">Answers</th>
                                        <th scope="col">Discussion started by</th>
                                        <th scope="col">Last post</th>
                                    </tr>
                                </thead>

                                <tbody>
                                    {% for thread in page_obj %}
                                        <tr class="text-center align-middle">
                                            <th scope="row">
                                                <a class="text-decoration-none" href="{{ thread.get_absolute_url }}">{{ thread.title }}</a>
                                            </th>
                                            <td>{{ thread.category }}</td>
                                            <td>{{ thread.get_answers }}</td>
                                            <td class="primary-text-color">
                                                {% if thread.creator.user.account.is_active %}
                                                    {{ thread.creator }}
                                                {% else %}
                                                    user deleted
                                                {% endif %}
                                            </td>
                                            {% for post in thread.post_set.all %}
                                                {% if forloop.last %}
                                                    <td>{{ post.mod_date|timesince|upto:"," }} ago
                                                        <div class="primary-text-color">
                                                            {% if post.author.user.account.is_active %}
                                                                {{ post.author }}
                                                            {% else %}
                                                                user deleted
                                                            {% endif %}
                                                        </div>
                                                    </td>
                                                {% endif %}
                                            {% endfor %}
                                        </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    {% endif %}

                    {% if is_paginated %}
                        <ul class=" pagination justify-content-center">
                            {% if page_obj.has_previous %}
                                <li class="page-item">
                                    <a class="page-link" href="?page={{ page_obj.previous_page_number }}">Previous</a>
                                </li>
                            {% endif %}

                            {% for page in page_obj.paginator.page_range %}
                                {% if page == page_obj.number %}
                                    <li class="page-item active">
                                        <a class="page-link current" href="?page={{ page_obj.number }}">{{ page_obj.number }}</a>
                                    </li>
                                {% else %}
                                    <li class="page-item">
                                        <a class="page-link" href="?page={{ page }}">{{ page }}</a>
                                    </li>
                                {% endif %}
                            {% endfor %}

                            {% if page_obj.has_next %}
                                <li class="page-item">
                                    <a class="page-link" href="?page={{ page_obj.next_page_number }}">Next</a>
                                </li>
                            {% endif %}
                        </ul>
                    {% endif %}
                </div>
            </div>
        </div>
    </section>

    <script>
        let th_titles = []
        {% for item in threads_titles %}
            th_titles.push({'label':'{{ item.title }}', 'value':'{{ item.id }}'})
        {% endfor %}

        // Add threads info to searchbar
        $('#search-thread').autocomplete({
            source: th_titles,
            appendTo: '#menu-th-titles',
            select: function (event, ui) {
                // prevent autocomplete from updating the textbox
                event.preventDefault();
                $(this).val(ui.item.label);
                // save selected id to hidden input
                $("#search-thread-id").val(ui.item.value);
            },
            focus: function (event, ui) {
                event.preventDefault();
                $(this).val(ui.item.label);
            }
        });

        $('li.page-item a').each(function() {
            let url = $(this).prop('href');
            let last_url = url.substring(url.lastIndexOf('/') + 2);

            {% if search_title %}
                let search_title_url = '{% url 'forum' %}?th-title={{ search_title }}&' + last_url
                 $(this).prop('href', search_title_url)
            {% elif search_category %}
                let search_category_url = '{% url 'forum' %}?th-category={{ search_category }}&' + last_url
                 $(this).prop('href', search_category_url)
            {% endif %}
        });
    </script>
{% endblock content %}
